<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <title></title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width">

        <link rel="stylesheet" href="css/bootstrap.min.css">
        <style>
            body {
                padding-top: 50px;
                padding-bottom: 20px;
            }
        </style>
        <link rel="stylesheet" href="css/bootstrap-theme.min.css">
        <link rel="stylesheet" href="css/main.css">

        <script src="js/vendor/modernizr-2.6.2-respond-1.1.0.min.js"></script>
    </head>
    <body>
        <!--[if lt IE 7]>
            <p class="chromeframe">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> or <a href="http://www.google.com/chromeframe/?redirect=true">activate Google Chrome Frame</a> to improve your experience.</p>
        <![endif]-->
        <div class="navbar navbar-inverse navbar-fixed-top">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="#">Protocols</a>
                </div>
                <div class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                        <li><a href="index.html">Overview</a></li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <h2>Public chat room</h2>

                    <h3>Structure</h3>
                    <p>The message structure looks like:</p>
                    <pre>PROTOCOL:TYPE:COMMAND<br />PARAMETERS*<br /><br />END</pre>
                    <p>With each message some parameters can be sent. The params have to be in the format <code>&lt;key&gt;:&lt;value&gt;</code></p>

                    <h3>Information about the protocol</h3>
                    <p>The protocol`s abbreviation is: <code>ukpchat1</code></p>

                    <h3>Types</h3>
                    <p>There are a number of types:</p>
                    <ul>
                        <li><code>r</code> for Request</li>
                        <li><code>a</code> for Answer</li>
                        <li><code>e</code> for Error</li>
                        <li><code>p</code> for Ping</li>
                    </ul>

                    <h3>Open Connection</h3>
                    <p>Initially the client must open a socket (a raw tcp connection). The client sends:</p>
                    <pre>ukpchat1:r:CONNECT<br /><br />END</pre>

                    <hr />

                    <h3>Client Commands</h3>
                    <h4>LOGIN</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Request</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Server</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td><i>&lt;String&gt; username (optional)</i></td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>If the username is not specified the server tries to log in the client automatically using an existing session.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:r:LOGIN<br /><br />END</pre>
                                <pre>ukpchat1:r:LOGIN<br />login: &lt;username&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Answers</th>
                            <td><a href="#server-login">LOGIN</a></td>
                        </tr>
                    </table>

                    <h4>SEND</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Request</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Server</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; message</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>It has one required header, <i>message</i>, which contains the message which will be displayed on any client.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:r:SEND<br />message: &lt;message&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Answers</th>
                            <td><a href="#server-message">MESSAGE</a></td>
                        </tr>
                    </table>

                    <h4>LOGOUT</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Request</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Server</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td><i>None</i></td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>It logs the user off and after that it is possible for the client to log in again with an other username.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:r:LOGOUT<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Answers</th>
                            <td><a href="#server-logout">LOGOUT</a></td>
                        </tr>
                    </table>

                    <hr />

                    <h3>Server Commands</h3>
                    <h4 id="server-login">LOGIN</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Answer</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td><i>None</i></td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>This message is sent after successful login.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:a:LOGIN<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-login">LOGIN</a></td>
                        </tr>
                    </table>

                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Error</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; code</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td><b>Error Codes:</b>
                                <ul>
                                    <li>er001: username is already taken</li>
                                    <li>er002: too many connections</li>
                                    <li>er003: you are logged in already</li>
                                </ul></td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:e:LOGIN<br />code: &lt;code&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-login">LOGIN</a></td>
                        </tr>
                    </table>


                    <h4 id="server-logout">LOGOUT</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Answer</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td><i>None</i></td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>This message is sent after successful logout.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:a:LOGOUT<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-logout">LOGOUT</a></td>
                        </tr>
                    </table>
                    
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Error</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; code</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td><b>Error Codes:</b>
                                <ul>
                                    <li>er101: you are not logged in</li>
                                </ul></td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:e:LOGOUT<br />code: &lt;code&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-logout">LOGOUT</a></td>
                        </tr>
                    </table>

                    <h4 id="server-message">MESSAGE</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Request</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; username<br />&lt;String&gt; message</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>-</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:r:MESSAGE<br />username: &lt;username&gt;<br />message: &lt;message&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-message">MESSAGE</a></td>
                        </tr>
                    </table>
                    
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Error</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; code</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td><b>Error Codes:</b>
                                <ul>
                                    <li>er101: you are not logged in</li>
                                    <li>er201: message cannot be blank</li>
                                    <li>er202: message parse error</li>
                                </ul></td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:e:MESSAGE<br />code: &lt;code&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-message">MESSAGE</a></td>
                        </tr>
                    </table>
                    
                    <h4 id="server-message">USERS</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Request</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>*( &lt;String&gt; username )</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td>This request is fired after a login / logout of a user and is sent to all clients logged in.</td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:r:USERS<br />username: &lt;username&gt;<br />username: &lt;username&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td><a href="#client-login">LOGIN</a> <a href="#client-logout">LOGOUT</a></td>
                        </tr>
                    </table>
                    
                    <h4>Core</h4>
                    <table class="table table-bordered">
                        <tr>
                            <th class="col-lg-2">Type</th>
                            <td>Error</td>
                        </tr>
                        <tr>
                            <th>Destination</th>
                            <td>Client</td>
                        </tr>
                        <tr>
                            <th>Parameters</th>
                            <td>&lt;String&gt; code</td>
                        </tr>
                        <tr>
                            <th>Information</th>
                            <td><b>Error Codes:</b>
                                <ul>
                                    <li>er901: command does not exist</li>
                                    <li>er901: no command sent</li>
                                    <li>er902: parse error, not correct message format</li>
                                    <li>er903: no END found</li>
                                    <li>er904: no TYPE found</li>
                                    <li>er905: not correct encoding</li>
                                </ul></td>
                        </tr>
                        <tr>
                            <th>Example</th>
                            <td>
                                <pre>ukpchat1:e:CORE<br />code: &lt;code&gt;<br /><br />END</pre>
                            </td>
                        </tr>
                        <tr>
                            <th>Triggers</th>
                            <td>Each request</td>
                        </tr>
                    </table>
                    
                    <hr />
                    
                    <h3>ukpchat1 Frame Definition - EBNF</h3>
                    <p>Definition of a valid ukpchat1 frame with augmented Backus-Naur Form (BNF) used in the HTTP/1.1 (rfc2616):</p>
<pre>
LF                     = &lt;US-ASCII LF, linefeed&gt;

frame-stream           = 1*frame

frame                  = "ukpchat1:" type ":" command LF
                         *( parameter LF )
                         LF
                         LF
                         END

protocol               = "ukpchat1"

type                   = "r"
                         | "a"
                         | "e"

command                = client-command | server-command

client-command         = "CONNECT"
                         | "LOGIN"
                         | "SEND"
                         | "LOGOUT"

server-command         = "LOGIN"
                         | "LOGOUT"
                         | "MESSAGE"
                         | "USERS"
                         | "CORE"

parameter              = parameter-name ":" parameter-value
parameter-name         = 1*&lt;any CHAR except LF or ":"&gt;
parameter-value        = ( 1*&lt;any CHAR except LF&lt; | "{" 1*&lt;any CHAR except } "}" )

binary-content         = 1*OCTECT
</pre>
                </div>
            </div>
            <hr>
            <footer>
                <p>&copy; Copyright Ueli Kramer 2014</p>
            </footer>
        </div> <!-- /container -->        <script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.1/jquery.js"></script>
        <script>window.jQuery || document.write('<script src="js/vendor/jquery-1.10.1.js"><\/script>')</script>

        <script src="js/vendor/bootstrap.min.js"></script>

        <script src="js/main.js"></script>

        <script>
            var _gaq = [['_setAccount', 'UA-XXXXX-X'], ['_trackPageview']];
            (function(d, t) {
                var g = d.createElement(t), s = d.getElementsByTagName(t)[0];
                g.src = '//www.google-analytics.com/ga.js';
                s.parentNode.insertBefore(g, s)
            }(document, 'script'));
        </script>
    </body>
</html>
